<template>
	<xn-form-container
		:title="formData.id ? '编辑货品管理' : '增加货品管理'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="货品编码：" name="goodsCode">
				<a-input v-model:value="formData.goodsCode" placeholder="请输入货品编码" allow-clear />
			</a-form-item>
			<a-form-item label="货品名称：" name="goodsName">
				<a-input v-model:value="formData.goodsName" placeholder="请输入货品名称" allow-clear />
			</a-form-item>
			<a-form-item label="货品规格：" name="goodsModel">
				<a-input v-model:value="formData.goodsModel" placeholder="请输入货品规格" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="goodsForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import goodsApi from '@/api/biz/goodsApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		goodsCode: [required('请输入货品编码')],
		goodsName: [required('请输入货品名称')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				goodsApi
					.goodsSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
